Crypto++ 8.2 Free C++ class library of cryptographic schemes

Public Member Functions | List of all members
DL_PrivateKey_GFP< GP > Class Template Reference

Discrete Log (DL) private key in GF(p) groups. More...

Inheritance diagram for DL_PrivateKey_GFP< GP >:

## Public Member Functions
void | Initialize (RandomNumberGenerator &rng, unsigned int modulusBits)
| Create a private key. More...
void | Initialize (RandomNumberGenerator &rng, const Integer &p, const Integer &g)
| Create a private key. More...
void | Initialize (RandomNumberGenerator &rng, const Integer &p, const Integer &q, const Integer &g)
| Create a private key. More...
void | Initialize (const DL_GroupParameters_IntegerBased &params, const Integer &x)
| Initialize a private key over GF(p) More...
void | Initialize (const Integer &p, const Integer &g, const Integer &x)
| Initialize a private key over GF(p) More...
void | Initialize (const Integer &p, const Integer &q, const Integer &g, const Integer &x)
| Initialize a private key over GF(p) More...
Public Member Functions inherited from DL_PrivateKeyImpl< GP >
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object. More...
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &params)
| Generate a random key or crypto parameters. More...
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation. More...
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation. More...
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation. More...
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use. More...
const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const
| Retrieves abstract group parameters. More...
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()
| Retrieves abstract group parameters. More...
const Integer & | GetPrivateExponent () const
| Retrieves the private exponent. More...
void | SetPrivateExponent (const Integer &x)
| Sets the private exponent. More...
void | BERDecodePrivateKey (BufferedTransformation &bt, bool, size_t)
| Decode privateKey part of privateKeyInfo. More...
void | DEREncodePrivateKey (BufferedTransformation &bt) const
| Encode privateKey part of privateKeyInfo. More...
Public Member Functions inherited from DL_PrivateKey< GP::Element >
void | MakePublicKey (DL_PublicKey< GP::Element > &pub) const
| Initializes a public key from this key. More...
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value. More...
void | AssignFrom (const NameValuePairs &source)
| Initialize or reinitialize this key. More...
Public Member Functions inherited from DL_KeyImpl< PKCS8PrivateKey, GP >
OID | GetAlgorithmID () const
bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
const GP & | GetGroupParameters () const
GP & | AccessGroupParameters ()
Public Member Functions inherited from PKCS8PrivateKey
void | BERDecode (BufferedTransformation &bt)
| Decode this object from a BufferedTransformation. More...
void | DEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
virtual void | BERDecodeOptionalAttributes (BufferedTransformation &bt)
| Decode optional attributes. More...
virtual void | DEREncodeOptionalAttributes (BufferedTransformation &bt) const
| Encode optional attributes. More...
Public Member Functions inherited from ASN1CryptoMaterial< PrivateKey >
void | Save (BufferedTransformation &bt) const
| DER encode ASN.1 object. More...
void | Load (BufferedTransformation &bt)
| BER decode ASN.1 object. More...
Public Member Functions inherited from ASN1Object
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation. More...
Public Member Functions inherited from GeneratableCryptoMaterial
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters. More...
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors. More...
void | DoQuickSanityCheck () const
| Perform a quick sanity check. More...
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject. More...
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object. More...
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value. More...
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value. More...
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved. More...
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int. More...
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default. More...
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64. More...
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default. More...
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair. More...
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair. More...

## Additional Inherited Members
Public Types inherited from DL_PrivateKeyImpl< GP >
typedef GP::Element | Element
Public Types inherited from DL_PrivateKey< GP::Element >
typedef GP::Element | Element
Public Types inherited from DL_KeyImpl< PKCS8PrivateKey, GP >
typedef GP | GroupParameters
Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void CRYPTOPP_API | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present. More...

## Detailed Description

### template<class GP>
class DL_PrivateKey_GFP< GP >

Discrete Log (DL) private key in GF(p) groups.

Template Parameters

  GP | GroupParameters derived class

Definition at line 590 of file gfpcrypt.h.

## Member Function Documentation

## ◆ Initialize() [1/6]

template<class GP >

void DL_PrivateKey_GFP< GP >::Initialize | ( | RandomNumberGenerator & | rng,
|  | unsigned int | modulusBits
| ) |  |
| inline

Create a private key.

Parameters

  rng | a RandomNumberGenerator derived class
  modulusBits | the size of the modulus, in bits

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 601 of file gfpcrypt.h.

## ◆ Initialize() [2/6]

template<class GP >

void DL_PrivateKey_GFP< GP >::Initialize | ( | RandomNumberGenerator & | rng,
|  | const Integer & | p,
|  | const Integer & | g
| ) |  |
| inline

Create a private key.

Parameters

  rng | a RandomNumberGenerator derived class
  p | the modulus
  g | the generator

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 611 of file gfpcrypt.h.

## ◆ Initialize() [3/6]

template<class GP >

void DL_PrivateKey_GFP< GP >::Initialize | ( | RandomNumberGenerator & | rng,
|  | const Integer & | p,
|  | const Integer & | q,
|  | const Integer & | g
| ) |  |
| inline

Create a private key.

Parameters

  rng | a RandomNumberGenerator derived class
  p | the modulus
  q | the subgroup order
  g | the generator

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 622 of file gfpcrypt.h.

## ◆ Initialize() [4/6]

template<class GP >

void DL_PrivateKey_GFP< GP >::Initialize | ( | const DL_GroupParameters_IntegerBased & | params,
|  | const Integer & | x
| ) |  |
| inline

Initialize a private key over GF(p)

Parameters

  params | the group parameters
  x | the private exponent

Definition at line 628 of file gfpcrypt.h.

## ◆ Initialize() [5/6]

template<class GP >

void DL_PrivateKey_GFP< GP >::Initialize | ( | const Integer & | p,
|  | const Integer & | g,
|  | const Integer & | x
| ) |  |
| inline

Initialize a private key over GF(p)

Parameters

  p | the modulus
  g | the generator
  x | the private exponent

Definition at line 635 of file gfpcrypt.h.

## ◆ Initialize() [6/6]

template<class GP >

void DL_PrivateKey_GFP< GP >::Initialize | ( | const Integer & | p,
|  | const Integer & | q,
|  | const Integer & | g,
|  | const Integer & | x
| ) |  |
| inline

Initialize a private key over GF(p)

Parameters

  p | the modulus
  q | the subgroup order
  g | the generator
  x | the private exponent

Definition at line 643 of file gfpcrypt.h.

The documentation for this class was generated from the following file:

- gfpcrypt.h